#!/usr/bin/python

import sys, pygame
import agario
import time
import math
import agariobot

import logging
import traceback






class NormalGame(agario.GAME):
	#def __init__(self,wsurl,name,resolution=(600,600),multi=2.0,DEBUG=True,jc=None):
	def __init__(self,wsurl,name,resolution=(600,600),multi=.33,DEBUG=True,jc=None):
		self.playername=name
		self.screen_resolution=resolution
		self.screen_multi=multi
		self.gamemode=0
		self.gcYp=0
		self.gcXp=0
		self.splitTimer=None
		self.splitAllow=True
		pygame.init()
		self.joystick=False
		if jc!=None:
			self.joystick=True
			pygame.joystick.init()
			JS=pygame.joystick.Joystick(jc)
			JS.init()
		self.screen = pygame.display.set_mode(self.screen_resolution)
		self.font = pygame.font.SysFont("calibri",30)
		agario.GAME.__init__(self,wsurl,DEBUG)
		self.logger = logging.getLogger(__name__)

	def render(self):
		try:
			self.render2()
		except:
			print '-'*60
			traceback.print_exc(file=sys.stdout)
			print '-'*60

	def render2(self):
		self.screen.fill((255,255,255))
		(gcX,gcY)=self.gamecenter
		rcX=gcX*self.screen_resolution[0]/self.screen_multi/(self.gright-self.gleft)-self.screen_resolution[0]/2.0
		rcY=gcY*self.screen_resolution[1]/self.screen_multi/(self.gtop-self.gbottom)-self.screen_resolution[1]/2.0

		self.prevDots=self.dots
		if self.prevPos==(0.0,0.0):
			self.prevPos=(rcX,rcY)
			self.prevMoveVect=(rcX-self.prevPos[0],rcY-self.prevPos[1])


		if len(self.myids)==0:
			self.setplayer(self.playername)
			return
		reload(agariobot)
		agariobot.bot(self.screen,self,gcX,gcY,rcX,rcY)

		for event in pygame.event.get():
			if event.type==10 and event.button==2:
					self.gamemode=1
			if event.type==10 and event.button==1:
					self.gamemode=0
					self.split()
			if event.type==10 and event.button==0:
					self.gamemode=0
					self.shoot()
			if event.type==7:
					self.gamemode=0
					if event.axis==0 and int(event.value)==1:
						self.gcXp=2000
					if event.axis==0 and int(event.value)==-1:
						self.gcXp=-2000
					if event.axis==1 and int(event.value)==1:
						self.gcYp=2000
					if event.axis==1 and int(event.value)==-1:
						self.gcYp=-2000
					if event.axis==1 and int(event.value)==0:
						self.gcYp=0
					if event.axis==0 and int(event.value)==0:
						self.gcXp=0


			if event.type==4 and event.buttons[0]==1 or event.type==5:
				x=(event.pos[0]-self.screen_resolution[0]/2.0)*self.screen_multi*(self.gright-self.gleft)/self.screen_resolution[0]+gcX
				y=(event.pos[1]-self.screen_resolution[1]/2.0)*self.screen_multi*(self.gtop-self.gbottom)/self.screen_resolution[1]+gcY
#				self.gamemode=0
				self.moveto(x,y)
			if event.type==2:
				# if event.key==109: # m
				# 	self.gamemode=(self.gamemode+1)%2
				if event.key==27:  # <ESCAPE>
					self.quit()
				if event.key==115: #s
					self.spectating()
				if event.key==112: #p
					self.setplayer(self.playername)
				if event.key==119: # w
					self.shoot()
				if event.key==32: # <SPACE>
					self.split()
				if event.key==45:
					self.screen_multi+=0.05
				if event.key==43:
					self.screen_multi-=0.05

		pl=[]
		x=(self.gleft)*self.screen_resolution[0]/self.screen_multi/(self.gright-self.gleft)
		y=(self.gbottom)*self.screen_resolution[1]/self.screen_multi/(self.gtop-self.gbottom)
		pl.append((x-rcX,y-rcY))
		x=(self.gright)*self.screen_resolution[0]/self.screen_multi/(self.gright-self.gleft)
		y=(self.gbottom)*self.screen_resolution[1]/self.screen_multi/(self.gtop-self.gbottom)
		pl.append((x-rcX,y-rcY))
		x=(self.gright)*self.screen_resolution[0]/self.screen_multi/(self.gright-self.gleft)
		y=(self.gtop)*self.screen_resolution[1]/self.screen_multi/(self.gtop-self.gbottom)
		pl.append((x-rcX,y-rcY))
		x=(self.gleft)*self.screen_resolution[0]/self.screen_multi/(self.gright-self.gleft)
		y=(self.gtop)*self.screen_resolution[1]/self.screen_multi/(self.gtop-self.gbottom)
		pl.append((x-rcX,y-rcY))
		pygame.draw.lines(self.screen,(0,0,0),True,pl,3)
		font2 = pygame.font.SysFont("calibri",int(8.0/self.screen_multi))
		x=0
		y=0
		for i in self.topplayers:
			scoreboard = self.font.render("%10s"%i["name"], True,(0,0,0))
			self.screen.blit(scoreboard,(x,y))
			y+=20

		scoreboard = self.font.render("%0.2f %0.2f mode:%d"%(gcX/(self.gright-self.gleft),gcY/(self.gtop-self.gbottom),self.gamemode), True,(0,0,0))
		self.screen.blit(scoreboard,(0,self.screen_resolution[1]-20))

		for dot in self.dots.values():
			if dot.active:
				x=(dot.x)*self.screen_resolution[0]/self.screen_multi/(self.gright-self.gleft)
				y=(dot.y)*self.screen_resolution[1]/self.screen_multi/(self.gtop-self.gbottom)
				s=dot.size*self.screen_resolution[0]/self.screen_multi/(self.gright-self.gleft)

				pygame.draw.circle(self.screen,dot.color,(int(x-rcX),int(y-rcY)),int(s),0)

		for dot in self.dots.values():
			if dot.active:
				x=(dot.x)*self.screen_resolution[0]/self.screen_multi/(self.gright-self.gleft)
				y=(dot.y)*self.screen_resolution[1]/self.screen_multi/(self.gtop-self.gbottom)
				if dot.size>21:
					pass
					label = font2.render("%5s"%(dot.name,), True,(0,0,0))
					self.screen.blit(label,(x-rcX,y-rcY))
					label = font2.render("%0.000f"%(dot.area/100.,), True,(0,122,122))
					#label = font2.render("%0.000f"%(dot.area,), True,(0,122,122))
					#label = font2.render("%f"%(dot.size,), True,(0,122,122))
					self.screen.blit(label,(x-rcX,y-rcY-20))
		pygame.display.flip()
		self.prevDots=self.dots
		self.prevMoveVect=(rcX-self.prevPos[0],rcY-self.prevPos[1])
		self.prevPos=(rcX,rcY)

logging.basicConfig()
logger = logging.getLogger(__name__)
logger.setLevel(logging.WARNING)
#logger.info("Start")

try:
	c1=NormalGame(sys.argv[1],sys.argv[2],DEBUG=False,jc=int(sys.argv[3]))
except:
	c1=NormalGame(sys.argv[1],sys.argv[2],DEBUG=False)

c1.start()


